#include "RFL.h"

#define WIN32_LEAN_AND_MEAN 1
#include <Windows.h>

namespace hyplex::drakan
{
	void extractRFLResources(string_view inputRFL, string_view outputDir)
	{
		STARTUPINFO si{};
		PROCESS_INFORMATION pi{};

		si.cb = sizeof(si);

		//const string_view exePath = "..\\..\\RFLResourceDumper\\bin\\RFLResourceDumper_Debug_Win32.exe"_sv;
		const string_view exePath = ".\\RFLResourceDumper_Release_Win32.exe"_sv;

		if (!CreateProcessA((exePath + '\0').data(),
			("\""_sv + exePath + "\" \""_sv + inputRFL + '"' + '\0').data(),        // Command line
			nullptr,           // Process handle not inheritable
			nullptr,           // Thread handle not inheritable
			false,          // Set handle inheritance to FALSE
			0,              // No creation flags
			nullptr,           // Use parent's environment block
			(outputDir + '\0').data(),
			&si,            // Pointer to STARTUPINFO structure
			&pi))
			throw std::runtime_error("Failed to start RFLResourceDumper_Release_Win32.exe.");

		// Wait until child process exits.
		WaitForSingleObject(pi.hProcess, INFINITE);

		DWORD exitCode = 1;
		GetExitCodeProcess(pi.hProcess, &exitCode);

		// Close process and thread handles. 
		CloseHandle(pi.hProcess);
		CloseHandle(pi.hThread);

		if(exitCode != 0)
			throw std::runtime_error("RFLResourceDumper failed.");
	}
}